Subject: Re: linux-next: build failure after merge of the final tree

From: Stephen Rothwell <[email-masked]>
Date: Mon, 9 Jan 2012 17:20:16 +1100

On Mon, 9 Jan 2012 16:59:50 +1100 Stephen Rothwell <[email-masked]> wrote:
>
> On Thu, 5 Jan 2012 16:04:48 -0800 Andrew Morton <[email-masked]> wrote:
> >
> > On Thu, 5 Jan 2012 19:04:05 +1100
> > Stephen Rothwell <[email-masked]> wrote:
> > 
> > > After merging the final tree, today's linux-next build (sparc64 defconfig)
> > > failed like this:
> > > 
> > > In file included from include/trace/ftrace.h:567:0,
> > >                  from include/trace/define_trace.h:86,
> > >                  from include/trace/events/power.h:240,
> > >                  from kernel/trace/power-traces.c:14:
> > > include/trace/events/kmem.h: In function 'ftrace_test_probe_kmalloc':
> > > include/trace/events/kmem.h:45:1: error: implicit declaration of function 'check_trace_callback_type_kmalloc' [-Werror=implicit-function-declaration]
> > > include/trace/events/kmem.h: In function 'ftrace_test_probe_kmem_cache_alloc':
> > >
> > > ...
> > >
> > > include/trace/events/kmem.h:267:1: error: implicit declaration of function 'check_trace_callback_type_mm_page_alloc_extfrag' [-Werror=implicit-function-declaration]
> > > In file included from include/trace/ftrace.h:774:0,
> > >                  from include/trace/define_trace.h:86,
> > >                  from include/trace/events/power.h:240,
> > >                  from kernel/trace/power-traces.c:14:
> > > include/trace/events/kmem.h: In function 'perf_test_probe_mm_page_pcpu_drain':
> > > include/trace/events/kmem.h:256:1: error: implicit declaration of function 'check_trace_callback_type_mm_page_pcpu_drain' [-Werror=implicit-function-declaration]
> > > 
> > > I have no idea what has gone wrong here, but I did not get this error
> > > yesterday.  The only thing that touched include/trace/events/kmem.h is
> > > patch "mm-tracepoint: rename page-free events" from the akpm tree, but
> > > that was there yesterday as well and doesn't look suspicious.
> > 
> > Yes, it's not due to anything in the akpm tree.  Tracing stuff blew up.
> > 
> > > I just have to leave things broken for today in the hope that someone
> > > figures something out.  This does not affect my X86_64 allmodconfig build
> > > or my PowerPC builds (including an allyesconfig build).
> > 
> > It fails with sparc64 defconfig but succeeds with sparc64 allmodconfig.
> > Some config-dependent thing.  3.2 is OK, so it's something in -next.
> > 
> > It could be that some far-off sparc64 Kconfig change is newly
> > triggering this.  
> > 
> > I suppose I could get off my ass and actually work out why it broke,
> > but the tracing code is too icky.
> 
> This failure is now in Linus' tree.  I am not sure when it got there.

Bisected down to:

8a25a2fd126c621f44f3aeaef80d51f00fc11639 is the first bad commit
commit 8a25a2fd126c621f44f3aeaef80d51f00fc11639
Author: Kay Sievers <[email-masked]>
Date:   Wed Dec 21 14:29:42 2011 -0800

    cpu: convert 'cpu' and 'machinecheck' sysdev_class to a regular subsystem
    
    This moves the 'cpu sysdev_class' over to a regular 'cpu' subsystem
    and converts the devices to regular devices. The sysdev drivers are
    implemented as subsystem interfaces now.
    
    After all sysdev classes are ported to regular driver core entities, the
    sysdev implementation will be entirely removed from the kernel.
    
    Userspace relies on events and generic sysfs subsystem infrastructure
    from sysdev devices, which are made available with this conversion.
    
    Cc: Haavard Skinnemoen <[email-masked]>
    Cc: Hans-Christian Egtvedt <[email-masked]>
    Cc: Tony Luck <[email-masked]>
    Cc: Fenghua Yu <[email-masked]>
    Cc: Arnd Bergmann <[email-masked]>
    Cc: Benjamin Herrenschmidt <[email-masked]>
    Cc: Paul Mackerras <[email-masked]>
    Cc: Martin Schwidefsky <[email-masked]>
    Cc: Heiko Carstens <[email-masked]>
    Cc: Paul Mundt <[email-masked]>
    Cc: "David S. Miller" <[email-masked]>
    Cc: Chris Metcalf <[email-masked]>
    Cc: Thomas Gleixner <[email-masked]>
    Cc: Ingo Molnar <[email-masked]>
    Cc: "H. Peter Anvin" <[email-masked]>
    Cc: Borislav Petkov <[email-masked]>
    Cc: Tigran Aivazian <[email-masked]>
    Cc: Len Brown <[email-masked]>
    Cc: Zhang Rui <[email-masked]>
    Cc: Dave Jones <[email-masked]>
    Cc: Peter Zijlstra <[email-masked]>
    Cc: Russell King <[email-masked]>
    Cc: Andrew Morton <[email-masked]>
    Cc: Arjan van de Ven <[email-masked]>
    Cc: "Rafael J. Wysocki" <[email-masked]>
    Cc: "Srivatsa S. Bhat" <[email-masked]>
    Signed-off-by: Kay Sievers <[email-masked]>
    Signed-off-by: Greg Kroah-Hartman <[email-masked]>

:040000 040000 9f2bf9fd8c5aded0a2ee73e897384dcf751c7be3 e0a42f67ed44979aa64b2be4c6de265832e940ca M	arch
:040000 040000 f910621f42e19d9d023350ef0dc29e82d1dc9087 513187817d23d20eccbd12fae6d54ab46f6224a3 M	drivers
:040000 040000 1e4d8217d84d59840615679ff4c28b04bb6ff635 296baef04fc04321aba25b5bdbc8e7210765e7b8 M	include
:040000 040000 65e9478a4ef764542a61132c53378ef89d8677ba 671ac443ad56c84707d80c84eee9e3902fc5edea M	kernel

-- 
Cheers,
Stephen Rothwell                    [email-masked]
http://www.canb.auug.org.au/~sfr/